<script lang="ts" setup>
import { useLoadingStore } from '@/stores/loading'
import { useMatrerialStore } from '@/stores/matrerial'
import type { Matrerial } from '@/types/Matrerial'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const matrerialStore = useMatrerialStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Price',
    key: 'price',
    value: 'price'
  },
  {
    title: 'Quantity',
    key: 'quantity',
    value: 'quantity'
  },
  {
    title: 'Min',
    key: 'min',
    value: 'min'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
    // value: (item: any | Employee) => {
    //     return item.role.join(", ")
    // }
  },

  { title: 'Actions', key: 'actions', sortable: false }
]

const loadingStore = useLoadingStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initilMatrerial: Matrerial = {
  id: -1,
  name: '',
  price: 0.0,
  quantity: 0,
  min: 0,
  status: 'Low'
}
const editedMatrerial = ref<Matrerial>(JSON.parse(JSON.stringify(initilMatrerial)))

let editedIndex = -1
let lastId = 4
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedMatrerial.value = Object.assign({}, initilMatrerial)
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  closeDelete()
  await matrerialStore.deleteMatrerial(editedMatrerial.value)
}
function editItem(item: Matrerial) {
  editedMatrerial.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Matrerial) {
  editedMatrerial.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedMatrerial.value = Object.assign({}, initilMatrerial)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  closeDialog()
  await matrerialStore.saveMatrerial(editedMatrerial.value)
}

onMounted(() => {
  matrerialStore.getMatrerials()
})
</script>
<template>
  <!-- <div>
    <v-table>
      <thead>
        <tr>
          <th class="text-left">ID</th>
          <th class="text-left">Email</th>
          <th class="text-left">Full Name</th>
          <th class="text-left">Gender</th>
          <th class="text-left">Roles</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="item in Matrerials" :key="item.id">
          <td>{{ item.id }}</td>
          <td>{{ item.email }}</td>
          <td>{{ item.fullName }}</td>
          <td>{{ item.gender }}</td>
          <td>{{ item.roles.join(',') }}</td>
        </tr>
      </tbody>
    </v-table>
  </div> -->
  <div>
    <v-data-table :headers="headers" :items="matrerialStore.matrerials">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Matrerials</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Matrerial </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Matrerial Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMatrerial.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMatrerial.price"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Price"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMatrerial.quantity"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Quantity"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMatrerial.min"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Min"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Status"
                          :items="['Available', 'Low']"
                          v-model="editedMatrerial.status"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="matrerialStore.getMatrerials"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
